package de.datenkollektiv.shadowland.economy.arch;

/**
 * @author fluffi
 *
 */
public aspect ShadowlandEconomyArchitectureConstraints {

	// define the shadowland economy layers
	private pointcut daoLayer(): within(de.datenkollektiv.shadowland.economy.dao..*.*);
	private pointcut serviceLayer(): within(de.datenkollektiv.shadowland.economy.service..*.*);
	private pointcut webLayer(): within(de.datenkollektiv.shadowland.economy.web..*.*);

	private pointcut aModelObject(): within(de.datenkollektiv.shadowland.economy.model..*.*);

	public pointcut inDaoLayer() : 
        execution(public de.datenkollektiv.shadowland.economy.dao..new(..));

	declare warning: anyPublicConstructorExecution():
		"don't use public constructor ouside tests, use DI";

	// protect spring managed beans
	declare error: call((de.datenkollektiv.shadowland.economy.dao..*).new(..)) && !withinTest():
		"please do not use Spring managed beans directly";
	wthin(daoLayer) && call(serviceLa)
}
