package de.datenkollektiv.shadowland.economy.arch;

/**
 * @author fluffi
 */
public aspect TestUsage {

	pointcut junit3TestMethod(): within(junit.framework.TestCase+) && execution(* test*());
	pointcut junit4TestMethod(): execution(@org.junit.Test * *(..));

	declare warning: junit3TestMethod():
	    "please follow the code convention and upgrade to using JUnit4 as definied in https://www.datenkollektiv.de/fluffi/wiki/CodingGuidlines#testnamingconvention";
	declare warning: junit4TestMethod() && !within(* ..*Tests):
	    "please follow the naming convention ClassUnderTestTests as definied in https://www.datenkollektiv.de/fluffi/wiki/CodingGuidlines#testnamingconvention";

	public pointcut junitTests(): junit3TestMethod() || junit4TestMethod();

}
