package de.datenkollektiv.spring.finder.impl;

import java.io.Serializable;
import java.util.List;

import org.springframework.orm.jpa.support.JpaDaoSupport;

import de.datenkollektiv.spring.finder.CrudDao;

public class CrudJpaDaoSupport<T, PK extends Serializable> extends JpaDaoSupport implements CrudDao<T, PK> {

	private Class<T> entityClass;

	// required by springframework
	public CrudJpaDaoSupport() {
		super();
	}

	public CrudJpaDaoSupport(Class<T> clazz) {
		super();
		entityClass = clazz;
	}

	@Override
	public T create(T newEntity) {
		getJpaTemplate().persist(newEntity);
		return newEntity;
	}

	@Override
	public T read(PK key) {
		return getJpaTemplate().find(entityClass, key);
	}

	@Override
	public void update(T transientEntity) {
		getJpaTemplate().merge(transientEntity);
	}

	@Override
	public void delete(T persistentEntity) {
		getJpaTemplate().remove(persistentEntity);
	}

	@Override
	@SuppressWarnings("unchecked")
	public List<T> executeFinder(String methodname, Object[] values) {
		// query name: TheSimpleClassName.findQueryName
		String queryName = entityClass.getSimpleName() + "." + methodname;
		return getJpaTemplate().findByNamedQuery(queryName, values);
	}

}
